#pragma once

#include <math.h>
#include <windows.h>
#define PI 3.14159265358979323846

class SoundGen
{
public:
	SoundGen(int samplesPerSecond);
	~SoundGen(void);

	int AddTimeSpace(int milliseconds);
	void AddSineWaveToTimeSpace(int spaceIndex, float frequency, float amplitude);

	int GetBufferLength();
	const BYTE* GetBuffer();

	void Clear();

protected:
	typedef struct SineWave
	{
		float Frequency;
		float Amplitude;

		SineWave* pNext;
	};

	typedef struct TimeSpace
	{
		int Index;
		int Samples;

		SineWave* pFirstSineWave;
		SineWave* pLastSineWave;

		TimeSpace* pNext;
	};

	void UpdateBuffer();
	int GenerateSpace(TimeSpace* pSpace, BYTE* targetBuffer);


	int SamplesPerSecond;

	TimeSpace* pFirstTimeSpace;
	TimeSpace* pLastTimeSpace;

	int BufferLength;
	bool BufferValid;
	BYTE* Buffer;
};