#include "StdAfx.h"
#include "WavFile.h"

WavFile::WavFile(int samplesPerSecond)
{
	ZeroMemory(&wex,sizeof(wex));
	wex.wFormatTag = WAVE_FORMAT_PCM;
	wex.nChannels = 1;
	wex.nSamplesPerSec = samplesPerSecond;
	wex.nAvgBytesPerSec = samplesPerSecond * 1 * 8 / 8;
	wex.nBlockAlign = 1 * 8 / 8;
	wex.wBitsPerSample = 8;
}

WavFile::~WavFile(void)
{
}

void WavFile::Save(const char* fileName, const BYTE* buffer, int length)
{
	FILE* file;
	fopen_s(&file,fileName,"wb");
	fwrite("RIFF",4,1,file);
	
	DWORD dwFileSize = length + 36 ; //velikost souboru = velikost dat+velikost hlaviky
	fwrite(&dwFileSize, sizeof(dwFileSize),1,file);

	fwrite("WAVEfmt ", 8,1, file) ;  //formt dat
	
	DWORD dwFmtSize = 16L;
	fwrite(&dwFmtSize, sizeof(dwFmtSize),1, file) ;  //velikost formtu dat

	fwrite(&wex.wFormatTag, sizeof(wex.wFormatTag),1, file) ;
	fwrite(&wex.nChannels, sizeof(wex.nChannels),1, file) ;
	fwrite(&wex.nSamplesPerSec, sizeof(wex.nSamplesPerSec),1, file) ;
	fwrite(&wex.nAvgBytesPerSec, sizeof(wex.nAvgBytesPerSec),1, file) ;
	fwrite(&wex.nBlockAlign, sizeof(wex.nBlockAlign),1, file) ;
	fwrite(&wex.wBitsPerSample, sizeof(wex.wBitsPerSample),1, file) ;
	
	fwrite("data", 4,1, file) ;  //data
	DWORD dwNum = length;
	
	fwrite(&dwNum, sizeof(dwNum),1, file) ;  //zapsat velikost dat
	fwrite(buffer, dwNum,1, file) ;  //zapsat data

	fclose(file);
}

void WavFile::Play(const BYTE* buffer, int length)
{
	HWAVEOUT wo;
	waveOutOpen(&wo,WAVE_MAPPER,&wex,NULL,NULL,NULL);

	WAVEHDR wh;
	ZeroMemory(&wh,sizeof(wh));
	wh.dwBufferLength=length;
	wh.lpData=(LPSTR)buffer;

	waveOutPrepareHeader(wo,&wh,sizeof(wh));

	waveOutWrite(wo,&wh,sizeof(wh));
	while(!(wh.dwFlags & WHDR_DONE));
	
	waveOutUnprepareHeader(wo,&wh,sizeof(wh));
	waveOutClose(wo);
}